package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import androidx.room.RewriteQueriesToDropUnusedColumns
import com.faraphel.tasks_valider.database.dao.base.BaseDao
import com.faraphel.tasks_valider.database.entities.StudentEntity


@Dao
interface StudentDao : BaseDao<StudentEntity> {
    @Query("SELECT * FROM `students`")
    override fun getAll(): List<StudentEntity>

    @Query("SELECT * FROM `students` WHERE id = :id")
    fun getById(id: Long): StudentEntity


    /**
    Allow to get all the students in a group
     */
    @Query(
        "SELECT * FROM `students` " +
        "JOIN `group_student` ON `students`.id = `group_student`.student_id " +
        "WHERE `group_student`.group_id = :groupId"
    )
    @RewriteQueriesToDropUnusedColumns
    fun filterByGroupId(groupId: Long): List<StudentEntity>
}
