package com.faraphel.tasks_valider.database.entities

import java.util.Locale
import com.faraphel.tasks_valider.database.entities.base.BaseEntity


open class PersonEntity (
    open val id: Long = 0,
    open val firstName: String,
    open val lastName: String,
) : BaseEntity() {
    /**
    Get the full name of the person
     */
    val fullName: String
        get() {
            return "${firstName.capitalize(Locale.ROOT)} ${lastName.uppercase()}"
        }
}
