package com.faraphel.tasks_valider.database.entities

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.ForeignKey
import com.faraphel.tasks_valider.database.entities.base.BaseEntity
import java.time.Instant


@Entity(
    tableName = "task_group",
    primaryKeys = [
        "task_id",
        "group_id"
    ],
    foreignKeys = [
        ForeignKey(
            entity = GroupEntity::class,
            parentColumns = ["id"],
            childColumns = ["group_id"],
            onDelete = ForeignKey.CASCADE
        ),
        ForeignKey(
            entity = TaskEntity::class,
            parentColumns = ["id"],
            childColumns = ["task_id"],
            onDelete = ForeignKey.CASCADE
        ),
        ForeignKey(
            entity = TeacherEntity::class,
            parentColumns = ["id"],
            childColumns = ["approval_teacher_id"],
            onDelete = ForeignKey.CASCADE
        ),
    ]
)
data class TaskGroupEntity (
    @ColumnInfo("task_id") val taskId: Long,
    @ColumnInfo("group_id") val groupId: Long,
    @ColumnInfo("approval_status") var approvalStatus: Boolean = false,
    @ColumnInfo("approval_teacher_id") val approvalTeacherId: Long? = null,
    @ColumnInfo("approval_time") val approvalTime: Instant? = null
) : BaseEntity()

